-- 带Icon的属性描述
Lua_CollectionAttrItem = class("Lua_CollectionAttrItem", Lua_DisplayObject);
function Lua_CollectionAttrItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_CollectionAttrItem:buildShowItem()
	self:superCall("buildShowItem");

	self.attrArr = Array();
end

function Lua_CollectionAttrItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local arr = string.split(data, "&");
	self.len = arr:getSize();
	for i = self.attrArr:getSize(), self.attrArr:getSize(), self.len do
		if i > self.len then
			self.attrArr[i]:setEnable(false);
		else
			break;
		end
	end

	local item;
	for i = 1, self.len do
		item = self.attrArr[i];
		if item == nil then
			item = Lua_CollectionAttrSubItem.new(self.content);
			self.attrArr:add(item);
		end
		item:setEnable(true);
		item:setData(arr[i]);
		-- item:setLocation(-165, -15 * (self.len - 1)  + (i - 1) * 30, 0);
		item:setLocation(-165, -30 * (i - 1), 0);
	end
end

function Lua_CollectionAttrItem:getHeight()
	return self.len * 30 + 10;
end

function Lua_CollectionAttrItem:dispose()
	if self.attrArr ~= nil then
		self.attrArr:dispose();
		self.attrArr = nil;
	end
	self._data = nil;
	self:superCall("dispose");
end





--------------------------------------------------





-- 带Icon的属性描述
Lua_CollectionAttrSubItem = class("Lua_CollectionAttrSubItem", Lua_DisplayObject);
function Lua_CollectionAttrSubItem:ctor(p)
	self:superCall("ctor", p, "CollectionAttrSubItem_skin");
end

function Lua_CollectionAttrSubItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_CollectionAttrSubItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local arr = string.split(data, "$");
	self.attrIcon:setAltas("common_altas_2", arr[1]);
	self.attrTxt.text = LanUtil.formateStr(460014, arr[2], arr[3])
end