-- 藏品柜详情信息
checkRequire("Lua_CollectionAttrItem");
Lua_CollectionDetailWindow = class("Lua_CollectionDetailWindow", Lua_Window);
function Lua_CollectionDetailWindow:ctor()
	self:superCall("ctor");

	self.layer = Lua_MainWinDefine.TIPS_WINDOW_LAYER;
	self.windowName = "Lua_CollectionDetailWindow";
	self.skinName = "CollectionDetailWindow_skin";
	self.showBlackMask = true;
	self.isClickClose = true;
end

function Lua_CollectionDetailWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.startPosY = self.winBg.posY;
	self.containerHeight = 500;
	self.containerStartPosY = 93;

	self.itemIcon = Lua_ItemIcon.new(self.content);
	self.itemIcon:setLocation(-121, 192, 0);
	
	self.detailPanel = Lua_CollectionDetailPanel.new(self.content);
	self.detailPanel:setParent(self.content);
	self.detailPanel:setRectPivot(1);

	self.rewardBg:addClickFuntion(self, self.onBtnClick);
	self.shareBtn:addClickFuntion(self, self.onShareClick);

	self:addLuaEvent("UPDATE_COLLECTION_CABINET_INFO", self, self.updateShowInfo);
end

function Lua_CollectionDetailWindow:showWin(param)
	self:superCall("showWin", param);

	-- 只有藏品柜查看才有分享和领取奖励
	-- 道具tips只有介绍
	-- 聊天场景查看多个成长属性或附加属性描述
	local collectVo;
	if type(param) == "table" then -- 聊天场景和道具tips
		if param.isShowInfo == nil then -- 其他人
			self.isOther = true;
			collectVo = Lua_ToolVo.createToolVo(param.collection_item_id);
			collectVo:fromServer(param);
		else -- 自己或道具tips
			collectVo = DataCenter.collectionData:getCollectionVo(param.id);
			if collectVo == nil then -- 功能没开启
				collectVo = Lua_ToolVo.createToolVo(param.id);
			end
		end
	elseif type(param) == "number" then -- 查看
		collectVo = DataCenter.collectionData:getCollectionVo(param);
	end

	if collectVo == nil then
		self:hide();
	end
	self:showDetailInfo(collectVo);
end

function Lua_CollectionDetailWindow:updateShowInfo(isRefrsh)
	if self.isOther then
		return; -- 其他人不刷新界面
	end
	self:showDetailInfo(self.showCollectVo);
end

function Lua_CollectionDetailWindow:showDetailInfo(showVo)
	self.showCollectVo = showVo;
	-- print(self.showData, self.showCollectVo, showVo);

	if showVo.is_have == 0 then
		self.shareBtn:setLangValue(460000);
	elseif showVo.is_have == 1 then
		self.shareBtn:setLangValue(460001);
	end

	self.rewardObj:SetActive(showVo.is_active == 1 and showVo.is_draw_active_reward == 0);
	self:showRedDot(showVo.is_active == 1 and showVo.is_draw_active_reward == 0);
	self.tipsTxt:setEnable(showVo.is_have == 0);
	self.shareBtn:setEnable(true);
	if type(self.showData) == "table" then
		self.rewardObj:SetActive(false);
		self:showRedDot(false);
		self.tipsTxt:setEnable(false);
		self.shareBtn:setEnable(false);
	end
	self:updatePropertyInfo(showVo);
end

function Lua_CollectionDetailWindow:showRedDot(bShow)
	if bShow == true then
		if self.redPoint == nil then
			self.redPoint = Lua_RedPointIcon.new(self.rewardObj);
			self.redPoint:setLocation(25, 25, 0);
			self.redPoint:createRedPointEff();
		end
		self.redPoint:updateRedPointShow(true);
	else
		if self.redPoint ~= nil then
			self.redPoint:updateRedPointShow(false);
		end
	end
end

function Lua_CollectionDetailWindow:updatePropertyInfo(collectionVo)
	self.itemIcon:setData(collectionVo);
	self.itemNameTxt.text = collectionVo.name;

	self.desTxt:setEnable(false);
	self.tipsTxt:setEnable(false);
	self.detailPanel:setData(self.showData);
	local height = self.detailPanel:getHeight();
	LuaUtil.setRectSize(self.detailPanel.mainContent, 360, height);

	if height > self.containerHeight then
		if self.desContainer == nil then
			self.desContainer = Lua_DragContainer.new(self.content, 360, self.containerHeight, Lua_AxisDefine.Vertical);
			self.desContainer:setRectPivot(1);
			self.desContainer:setLocation(0, self.containerStartPosY, 0);
		end
		self.desContainer:setEnable(true);

		self.detailPanel:setParent(self.desContainer.sub);
		self.detailPanel:setLocation(0, self.containerHeight / 2);
	else
		if self.desContainer ~= nil then
			self.desContainer:setEnable(false);
		end
		self.detailPanel:setParent(self.content);
		self.detailPanel:setLocation(0, self.containerStartPosY);
	end

	if type(self.showData) == "table" then -- 聊天场景和道具tips
		self.getTimeTxt:setLangValue(460016);
		self.timeTxt.text = collectionVo.effect_des;
		height = height > self.containerHeight and self.containerHeight or height;
		self.winBg:SetDimensions(434, self.startPosY - (self.containerStartPosY - height) + 30);
	else -- 藏品柜查看
		self.getTimeTxt:setLangValue(460015);
		if collectionVo.is_have == 0 and collectionVo.is_active == 0 then -- 未拥有未激活
			self.timeTxt:setLangValue(460002);
			self.shareBtn:setLocation(0, self.containerStartPosY - height - 67);
			self.winBg:SetDimensions(434, self.startPosY - self.shareBtn.posY + 60);
		else
			self.timeTxt.text = os.date("%Y/%m/%d", collectionVo.get_tick);
			height = height > self.containerHeight and self.containerHeight or height;
			self.shareBtn:setLocation(0, self.containerStartPosY - height - 40);
			local posY = self.startPosY - self.shareBtn.posY + 60;
			self.winBg:SetDimensions(434, posY);
		end
	end
end

function Lua_CollectionDetailWindow:onBtnClick(go)
	Lua_ProxyManager.getProxy("Lua_CollectionProxy"):sReceiveCollection(self.showData);
end

function Lua_CollectionDetailWindow:onShareClick(go)
	local collectionVo = DataCenter.collectionData:getCollectionVo(self.showData);
	if collectionVo.is_have == 0 then
		if collectionVo.func_open_id ~= nil and DataCenter.funcOpenData:isOpened(collectionVo.func_open_id, true) ~= true then
			-- OperateAlert.showLangValue(460003);
			return;
		end
		if collectionVo.func_path_id ~= nil then
			DataCenter.funcPathUtil:gotoFunction(collectionVo.func_path_id, true);
		end
	elseif collectionVo.is_have == 1 then
		local param = {id = self.showData, posX = self.shareBtn.posX, posY = self.shareBtn.posY};
		Lua_WindowUtil.openWin("Lua_CollectionShareWindow", Lua_WinParam.ACTION_OPEN, param);
	end
end

function Lua_CollectionDetailWindow:dispose()
	if self.itemIcon ~= nil then
		self.itemIcon:dispose();
		self.itemIcon = nil;
	end
	if self.desContainer ~= nil then
		self.desContainer:dispose();
		self.desContainer = nil;
	end
	if self.redPoint ~= nil then
		self.redPoint:dispose();
		self.redPoint = nil;
	end
	self.showCollectVo = nil;

	self:superCall("dispose");
end





--------------------------------------------------





Lua_CollectionDetailPanel = class("Lua_CollectionDetailPanel", Lua_DragContainerItem);
function Lua_CollectionDetailPanel:ctor(p)
	self:superCall("ctor", p, "CollectionDetailPanel_skin");
end

function Lua_CollectionDetailPanel:buildShowItem()
	self:superCall("buildShowItem");

	self.posY = 0;
	self.showItemList = {};
	self.hideItemList = {};
end

function Lua_CollectionDetailPanel:setData(initInfo)
	self.initInfo = initInfo;
	if type(initInfo) == "table" then
		if initInfo.collection_item_id ~= nil then
			self.collectionVo = Lua_ToolVo.createToolVo(initInfo.collection_item_id);
			self.collectionVo:fromServer(initInfo);
		else
			self.collectionVo = DataCenter.collectionData:getCollectionVo(initInfo.id);
			if self.collectionVo == nil then -- 功能未开启
				self.collectionVo = Lua_ToolVo.createToolVo(initInfo.id);
			end
		end
	elseif type(initInfo) == "number" then
		self.collectionVo = DataCenter.collectionData:getCollectionVo(initInfo);
	end

	self.posY = 0;
	self:updateCollectionDesInfo();

	LuaUtil.setObjPos(self.showObj, 0, self:getHeight() / 2, 0);
end

function Lua_CollectionDetailPanel:updateCollectionDesInfo()
	self.desTxt.text = self.collectionVo.des;
	self.desTxt:resetSize();

	local info = self.collectionVo.target_value;
	local targetValue = getConfig(info[1], info[2], info[3]);
	self.tipsTxt.text = LanUtil.formateStr(self.collectionVo.task_des, self.collectionVo.obtain_progress, targetValue);
	self.tipsTxt:setLocation(0, -73 - (self.desTxt.height - 40));

	self.tipsTxt:setEnable(false);
	if type(self.initInfo) == "table" then -- 聊天场景和道具tips
		self.propertyObj:SetActive(true);
		self:setPropertyInfo();
	else -- 藏品柜查看
		if self.collectionVo.is_have == 0 and self.collectionVo.is_active == 0 then -- 未拥有未激活
			self.posY = self.tipsTxt.posY;
			self.tipsTxt:setEnable(true);
			self.propertyObj:SetActive(false);
		else
			self.propertyObj:SetActive(true);
			self:setPropertyInfo();
		end
	end
end

function Lua_CollectionDetailPanel:setPropertyInfo()
	self:returntItem();
	self:setCommonProperty();
	self:setChangeProperty();
	self:setOtherProperty();
end

function Lua_CollectionDetailPanel:returntItem()
	local item;
	for _, itemArr in pairs(self.showItemList) do
		for i = 1, itemArr:getSize() do
			item = itemArr:remove(1);
			if item ~= nil then
				item:setEnable(false);
				if item.classname == "Lua_CollectionDesItem" then
					self.hideItemList[1]:add(item);
				elseif item.classname == "Lua_CollectionAttrItem" then
					self.hideItemList[2]:add(item);
				elseif item.classname == "Lua_PropertyDesItem" then
					self.hideItemList[3]:add(item);
				end
			else
				break;
			end
		end
	end
end

function Lua_CollectionDetailPanel:createCellItem(data, itemType)
	if self.hideItemList[itemType] == nil then
		self.hideItemList[itemType] = Array()
	end

	local item;
	local arr = self.hideItemList[itemType];
	if arr:getSize() > 0 then
		item = arr:remove(1);
	else
		if itemType == 1 then
			item = Lua_CollectionDesItem.new(self.propertyObj);
		elseif itemType == 2 then
			item = Lua_CollectionAttrItem.new(self.propertyObj);
		elseif itemType == 3 then
			item = Lua_PropertyDesItem.new(self.propertyObj);
		end
	end
	item:setData(data);
	item:setEnable(true);

	if self.showItemList[itemType] == nil then
		self.showItemList[itemType] = Array()
	end
	self.showItemList[itemType]:add(item);
	return item;
end

-- 普通属性
function Lua_CollectionDetailPanel:setCommonProperty()
	self.posY = self.desTxt.posY - self.desTxt.height - 30;
	local item = self:createCellItem(LanUtil.getValue(460004), 1);
	item:setLocation(0, self.posY);

	local configArr = self.collectionVo.configArr;
	for i = 1, configArr:getSize() do
		if configArr[i].normal_prop ~= nil then
			self.posY = self.posY - item:getHeight();

			item = self:createCellItem(configArr[i].normal_desc .. "&yahei_font&797878", 1);
			item:setLocation(0, self.posY);

			self.posY = self.posY - item:getHeight();
			item = self:createCellItem(self:getTheAttrStr(configArr[i].normal_prop), 2);
			item:setLocation(0, self.posY);
		end
	end
	self.posY = self.posY - item:getHeight();
end

-- 成长属性
function Lua_CollectionDetailPanel:setChangeProperty()
	local configArr = self.collectionVo.configArr;
	local tag, changeIdx = self.collectionVo:changeInfo();
	if tag == 2 then
		local item = self:createCellItem(LanUtil.getValue(460005), 1);
		item:setLocation(0, self.posY);
		
		local str;
		local singleStr
		local progressStr;
		local info;
		local targetValue;
		for i = 1, changeIdx do
			self.posY = self.posY - item:getHeight();

			singleStr, progressStr = self:getTheDesStr(configArr[i].prop, self.collectionVo.grow_progress);
			if type(self.initInfo) == "table" then -- 聊天场景和道具tips
				str = configArr[i].title_desc2 .. "，" .. configArr[i].change_desc .. "：" .. singleStr;
			else
				str = configArr[i].title_desc .. "，" .. configArr[i].change_desc .. "：" .. singleStr;
			end
			item = self:createCellItem(str, 3);
			item:setLocation(0, self.posY);

			-- 道具tips不显示
			if not (type(self.initInfo) == "table" and self.initInfo.isShowInfo == false) then
				self.posY = self.posY - item:getHeight();

				info = getConfig("total_task", configArr[1].grow_cond_id);
				targetValue = info.client_condition == nil and info.progress
					or getConfig(info.client_condition[1], info.progress, info.client_condition[2]);
				item = self:createCellItem(LanUtil.formateStr(460006, self.collectionVo.grow_progress, targetValue / configArr[1].each), 3);
				item:setLocation(0, self.posY);

				self.posY = self.posY - item:getHeight();
				item = self:createCellItem(LanUtil.formateStr(460007, progressStr), 3);
				item:setLocation(0, self.posY);
			end
		end
		self.posY = self.posY - item:getHeight();
	end
end

-- 附加属性
function Lua_CollectionDetailPanel:setOtherProperty()
	local configArr = self.collectionVo.configArr;
	local tag, changeIdx = self.collectionVo:changeInfo();
	local startIdx = tag == 1 and 1 or changeIdx + 1;
	local str = "";
	if startIdx <= configArr:getSize() then
		for i = startIdx, configArr:getSize() do
			str = str .. configArr[i].other_desc .. "：" .. configArr[i].other_value .. "%";
			if i ~= configArr:getSize() then
				str = str .. "\n";
			end
		end

		local item = self:createCellItem(LanUtil.getValue(460008), 1);
		item:setLocation(0, self.posY);
		self.posY = self.posY - item:getHeight();

		item = self:createCellItem(str, 3);
		item:setLocation(0, self.posY);
		self.posY = self.posY - item:getHeight();
	end
end

function Lua_CollectionDetailPanel:getTheAttrStr(attrDic)
	local vo;
	local str = "";
	for k,v in pairs(attrDic) do
		vo = DataCenter.attributesUtil:createAttrVo(k);
		str = str .. vo.attr_icon_2 .. "$" .. vo.show_name .. "$" .. v .. "&";
	end
	return str;
end

function Lua_CollectionDetailPanel:getTheDesStr(attrDic, progress)
	local vo;
	local str = "";
	local progressStr = "";
	for k,v in pairs(attrDic) do
		vo = DataCenter.attributesUtil:createAttrVo(k);
		str = str .. vo.show_name .. "+" .. v .. " ";
		progressStr = progressStr .. vo.show_name .. "+" .. v * progress .. " ";
	end
	return str, progressStr;
end

function Lua_CollectionDetailPanel:onPressClick()
	local winPos = LuaUtil.getTouchPosInverseObj(self.mainContent);
	local itemArr = self.showItemList[2];
	for i = 1, itemArr:getSize() do
		if itemArr[i]:checkInBound(winPos.x, winPos.y) then
			itemArr[i]:onPressClick();
			break;
		end
	end
end

function Lua_CollectionDetailPanel:getWidth()
	return 360;
end

function Lua_CollectionDetailPanel:getHeight()
	return self.desTxt.posY - self.posY;
end

function Lua_CollectionDetailPanel:dispose()
	for _, itemArr in pairs(self.showItemList) do
		itemArr:dispose();
		itemArr:clear();
	end
	for _, itemArr in pairs(self.hideItemList) do
		itemArr:dispose();
		itemArr:clear();
	end
	self.showItemList = nil;
	self.hideItemList = nil;
	self.collectionVo = nil;
	self:superCall("dispose");
end





--------------------------------------------------





-- 标题描述
Lua_CollectionDesItem = class("Lua_CollectionDesItem", Lua_DisplayObject);
function Lua_CollectionDesItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_CollectionDesItem:buildShowItem()
	self:superCall("buildShowItem");

	self.desTxt = UICreate.createLabel(self.content, "", 0, 0, 360, 0, 22);
	self.desTxt.fontName = Lua_MyUISettings.huakangFontName;
	self.desTxt.alignmentValue = 0;
	self.desTxt.verticalOverflowValue = 1;
	self.desTxt.colorStr = Lua_ColorDefine.transColorStr("CEBEA4");
end

function Lua_CollectionDesItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	local arr = string.split(data, "&");
	self.len = arr:getSize();
	if arr[2] ~= nil then
		self.desTxt.fontName = arr[2];
	else
		self.desTxt.fontName = Lua_MyUISettings.huakangFontName;
	end
	if arr[3] ~= nil then
		self.desTxt.colorStr = Lua_ColorDefine.transColorStr(arr[3]);
	else
		self.desTxt.colorStr = Lua_ColorDefine.transColorStr("CEBEA4");
	end
	self.desTxt.text = arr[1];
	self.desTxt:resetSize();
end

function Lua_CollectionDesItem:getHeight()
	if self.len > 1 then
		return self.desTxt.height + 10;
	else
		return self.desTxt.height + 15;
	end
end

function Lua_CollectionDesItem:dispose()
	if self.desTxt ~= nil then
		self.desTxt:dispose();
		self.desTxt = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end





--------------------------------------------------





-- 进阶/附加描述
Lua_PropertyDesItem = class("Lua_PropertyDesItem", Lua_DisplayObject);
function Lua_PropertyDesItem:ctor(p)
	self:superCall("ctor", p);
end

function Lua_PropertyDesItem:buildShowItem()
	self:superCall("buildShowItem");

	self.desTxt = UICreate.createLabel(self.content, "", 0, 11, 360, 0, 22);
	self.desTxt.pivot = Lua_WindowUtil.getPivot(1);
	self.desTxt.alignmentValue = 0;
	self.desTxt.verticalOverflowValue = 1;
	self.desTxt.colorStr = Lua_ColorDefine.transColorStr("DEE0E9");
	self.desTxt.clickScale = false;
	self.desTxt:addUrlClickFuntion(self, self.onClickFun);
end

function Lua_PropertyDesItem:setData(data)
	self._data = data;
	if data == nil then
		return;
	end

	self.desTxt.text = data;
	self.desTxt:resetSize();
end

-- -- 判断是否范围内
-- function Lua_PropertyDesItem:checkInBound(posX, posY)
-- 	local half_w = self.desTxt.width / 2;
-- 	local half_h = self.desTxt.height / 2;
-- 	self.minX = self.posX - half_w;
-- 	self.maxX = self.posX + half_w;
-- 	self.minY = self.posY - half_h;
-- 	self.maxY = self.posY + half_h;

-- 	if posX >= self.minX and posX <= self.maxX and posY >= self.minY and posY <= self.maxY then
-- 		return true;
-- 	end
-- 	return false;
-- end

-- function Lua_PropertyDesItem:onPressClick()
-- 	local urlStr = self.desTxt:getUrlByMousePos();
-- 	if urlStr ~= nil then
-- 		self:onClickFun(urlStr);
-- 	end
-- end

function Lua_PropertyDesItem:onClickFun(urlStr)
	local arr = string.split(urlStr, "_");
	if arr and arr:getSize() > 2 then
		if DataCenter.funcOpenData:isOpened(tonumber(arr[2]), true) ~= true then
			-- OperateAlert.showLangValue(460003);
			return;
		end
		DataCenter.funcPathUtil:gotoFunction(tonumber(arr[3]), true);
	end
end

function Lua_PropertyDesItem:getHeight()
	return self.desTxt.height;
end

function Lua_PropertyDesItem:dispose()
	if self.desTxt ~= nil then
		self.desTxt:dispose();
		self.desTxt = nil;
	end
	self._data = nil;

	self:superCall("dispose");
end